#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Plug-in:      Open file as mask
# Version:      0.12
# Date:         2022_07_25
# Copyright:    Ohnishi, Yasuo <gbfdf734a7b6gdE05SE@gmail.com>
# Website:      https://yasuo-ssi.hatenablog.com/
# Tested with:  GIMP 2.10.32

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from gimpfu import *
import os, glob

def import_file_as_mask(img, drawable, filename):
#    img = gimp.image_list()[0]
    pdb.gimp_message_get_handler(ERROR_CONSOLE)
    ismask = pdb.gimp_item_is_layer_mask(drawable)
    # whether drawable is mask or not?
    if ismask == TRUE: # if drawable is mask
        layer_active = pdb.gimp_layer_from_mask(drawable)
        #    get layer from mask
        drawable = layer_active
    """
    gimp.message("Start")
    gimp.message(str(drawable))
    """
    pdb.gimp_image_undo_group_start(img)
    # drawable = pdb.gimp_image_get_active_layer(img)
    try:
        imgload = pdb.gimp_file_load(filename, filename)
        disp = pdb.gimp_display_new(imgload)
    except Exception, error:
        print error
    pdb.gimp_edit_copy(imgload.layers[0])
    if pdb.gimp_drawable_has_alpha (drawable) == FALSE:
        pdb.gimp_layer_add_alpha (drawable)
    maskexist = pdb.gimp_layer_get_mask(drawable)
#    gimp.message(str(drawable))
    print(maskexist)
    try:
        mask = pdb.gimp_layer_create_mask(drawable, ADD_WHITE_MASK)
        if mask != None:
            pdb.gimp_layer_add_mask(drawable, mask)
    except Exception, error:
        print error
    pdb.gimp_layer_set_edit_mask(drawable, TRUE) # Activate Mask Edit Mode
    floating_sel = pdb.gimp_edit_paste(drawable.mask, False) # Paste Mask Image as Mask
    pdb.gimp_floating_sel_anchor(floating_sel) # Paste Layer Fixed
    pdb.gimp_layer_set_edit_mask(drawable, FALSE) # DisActivate Mask Edit Mode
    pdb.gimp_display_delete(disp)
    pdb.gimp_image_undo_group_end(img)
    return

register(
    "Open_file_as_mask",
    "Open file as mask",
    "Load file as mask",
    "Ohnishi, Yasuo",
    "Ohnishi, Yasuo",
    "2021-22 Ver 0.12",
    "Load file as mask...",
    "*",      # Alternately use RGB, RGB*, GRAY*, INDEXED etc.
    [
#   get currect active image and drawable to "img" and "drawable"
    (PF_IMAGE, "img", "Input image", None),
    (PF_DRAWABLE, "drawable", "Input drawable", None), 
    (PF_FILENAME, "filename", "Input filename", ""),
    ],
    [],
    import_file_as_mask, menu="<Image>/File/Open" )
main()
